@echo off
REM Vibegen.bat - Mp3/Wav to TI-WAV conversion script
REM Copyright (C) 2006 Olivier Armand
REM Caution, MS-Windows 'find' used, won't work with Cygwin.

REM ---------------------------------------------------------------------------
REM <<< Edit the values below to configure the converion >>>

REM You may adujst this value if ssrc returns sampling rate errors, and to
REM get a sound close to the original. 22130 is the perfect value for a 
REM Titanium HW3 for example, but choose 22200 when converting from a
REM 44100Hz Wav file, or from an mp3 file. This value strongly depends on
REM the model of your calculator, make a few tests to find a good one.
set SAMPLE_RATE=22200

REM If you want the sound to be scaled (if you want it to be played louder),
REM set the scaling factor. 3 is a good value. Don't set a value to keep
REM the input as it is.
set SCALE=3

REM ---------------------------------------------------------------------------

if ""%1"" == """" goto Usage
if ""%2"" == """" goto Usage

echo %1 | find ".mp3"
if %errorlevel% equ 0 goto Ismp3
ssrc_infile=%1
REM Wav file and no scaling?
if "%SCALE%"=="" goto Ssrc
goto Scale

:Ismp3
set mp3file=%1
REM MP3 file and no scaling?
if "%SCALE%"=="" goto Mp32Wav

:Scale
echo ---                       ---
echo --- Lame: Scale the input ---
echo ---                       ---
set mp3file=%1_scaled.mp3
lame.exe --scale %SCALE% %1 %mp3file%
if not exist %mp3file% goto Quit

:Mp32Wav
echo.
echo ---                  ---
echo --- Lame: Mp3 to Wav ---
echo ---                  ---
set wavfile=%1.wav
lame.exe --decode %mp3file% %wavfile%
if not exist %wavfile% goto Quit
set ssrc_infile=%wavfile%

:Ssrc
REM We only depend on ssrc because lame can't output anything else than
REM 16-bit-wide wav files when decoding...
echo.
echo ---                                ---
echo --- SSRC: Sampling rate conversion ---
echo ---                                ---
set ssrc_outfile=%1_ssrc.wav
ssrc.exe --rate %SAMPLE_RATE% --bits 8 %ssrc_infile%  %ssrc_outfile%
if not exist %ssrc_outfile% goto Quit

echo.
echo ---                         ---
echo --- Vibegen: Wav to TI file ---
echo ---                         ---
python vibegen.py %ssrc_outfile% %2
goto Quit

:Usage
echo Usage: vibegen.bat infile[.mp3/.wav] tiname
echo 'tiname' must be less than 8 character long.
goto QuitNoDel

:Quit
del %mp3file% %wavfile% %ssrc_infile% %ssrc_outfile%
:QuitNoDel
